#include <math.h>
#include <iostream>
#include <conio.h>
#include <vector>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(){
    cerr << "Input numbers count: ";
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    cerr << "Input numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cerr << "Input bin count: ";
    cin >> in.bin_count;
    return in;
}

void
find_minmax(vector<double> numbers, double &min, double &max) {
    min = numbers[0];
    max = numbers[0];
    for (size_t i = 1; i < numbers.size(); i++) {
        if (min > numbers[i])
            min = numbers[i];
        if (max < numbers[i])
            max = numbers[i];
    }
    return;
}

vector <size_t> make_histogramm(vector<double>numbers, size_t bin_count){
    double min, max;
    find_minmax(numbers, min, max);
    double binSize = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j <= bin_count - 1) && !found; j++) {
            auto lo = min + j * binSize;
            auto hi = min + (j + 1) * binSize;
            if ((numbers[i] >= lo) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
            bins[bin_count - 1]++;
    }
    int max_count = bins[0];
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] > max_count)
            max_count = bins[i];
    }
    if (max_count > 76) {
        for (size_t i = 0; i < bin_count; i++) {
            int count = bins[i];
            size_t height = 76 * (static_cast<double>(count) / max_count);
            bins[i] = height;
        }
    }
    return bins;
}

void show_histogramm(vector<size_t>bins){
    for (size_t i = 0; i < bins.size(); i++) {
        cout << bins[i] << "|";
        for (size_t j = 0; j < bins[i]; j++)
            cout << "*";
        cout << endl;
    }
    return;
}

int main() {
    Input in = input_data();
    auto bins = make_histogramm(in.numbers, in.bin_count);
    show_histogramm(bins);
    return 0;
}
